<div fxLayout="column">
    <table mat-table [dataSource]="uiDatas" class="edition-table"
           multiTemplateDataRows
           [attr.aria-describedby]="'SERIES.EDITION.TABLE.HEADERS.DESCRIBED_BY' | translate">

        <ng-container matColumnDef="editor">
            <th mat-header-cell *matHeaderCellDef
                scope="col"> {{'SERIES.EDITION.TABLE.HEADERS.EDITOR' | translate}} </th>
            <td mat-cell *matCellDef="let element; let index = dataIndex" [formGroup]="uiDatas[index].form">
                <app-editor-form
                        appearance="outline" classes="editable-field"
                        [displayLabel]="false"
                        [form]="getEditorGroup(index)">
                </app-editor-form>
            </td>
        </ng-container>

        <ng-container matColumnDef="bookType">
            <th mat-header-cell *matHeaderCellDef scope="col"> Type</th>
            <td mat-cell *matCellDef="let element; let index = dataIndex"
                [formGroup]="uiDatas[index].form.controls.editor">
                <app-book-type-form
                        appearance="outline" [classes]="'editable-field'"
                        style="padding-right: 1rem"
                        [displayLabel]="false"
                        [form]="getBookTypeFormGroup(index)">
                </app-book-type-form>
            </td>
        </ng-container>

        <ng-container matColumnDef="name">
            <th mat-header-cell *matHeaderCellDef
                scope="col"> {{'SERIES.EDITION.TABLE.HEADERS.SERIES_NAME' | translate}} </th>
            <td mat-cell *matCellDef="let element; let index = dataIndex" [formGroup]="uiDatas[index].form">
                <mat-form-field appearance="outline" class="editable-field" subscriptSizing="dynamic">
                    <input matInput formControlName="name">
                </mat-form-field>
            </td>
        </ng-container>

        <ng-container matColumnDef="totalCount">
            <th mat-header-cell *matHeaderCellDef
                scope="col"> {{'SERIES.EDITION.TABLE.HEADERS.TOTAL_COUNT' | translate}} </th>
            <td mat-cell *matCellDef="let element; let index = dataIndex" [formGroup]="uiDatas[index].form">
                <mat-form-field appearance="outline" class="editable-field" subscriptSizing="dynamic">
                    <input matInput type="number" formControlName="totalCount">
                </mat-form-field>
            </td>
        </ng-container>

        <ng-container matColumnDef="status">
            <th mat-header-cell *matHeaderCellDef
                scope="col"> {{'SERIES.EDITION.TABLE.HEADERS.STATUS' | translate}} </th>
            <td mat-cell *matCellDef="let element; let index = dataIndex" [formGroup]="uiDatas[index].form">
                <mat-form-field appearance="outline" class="editable-field" subscriptSizing="dynamic">
                    <mat-select formControlName="status">
                        <mat-option [value]="status"
                                    *ngFor="let status of seriesStatusEnum">{{"SERIES.PUBLICATION_STATE." + status | translate}}</mat-option>
                    </mat-select>
                </mat-form-field>
            </td>
        </ng-container>

        <ng-container matColumnDef="cycles">
            <th mat-header-cell *matHeaderCellDef
                scope="col"> {{'SERIES.EDITION.TABLE.HEADERS.CYCLES' | translate}}</th>
            <td mat-cell *matCellDef="let element; let index = dataIndex">
                <ng-container *ngIf="uiDatas[index].item as item">
                    <div fxLayoutGap="1rem">
                        <button mat-button type="button"
                                (click)="expandedElement = expandedElement === index ? null : index">
                            <span *ngIf="item.cycles.length > 0; else create"> {{'SERIES.EDITION.BUTTON.EDIT' | translate}} </span>
                            <ng-template #create>
                                <span> {{'SERIES.EDITION.BUTTON.CREATE' | translate}} </span>
                            </ng-template>
                            <fa-icon style="margin-left: 0.5rem" [icon]="['fas', 'pencil-alt']"></fa-icon>
                        </button>
                    </div>
                </ng-container>
            </td>

        </ng-container>

        <ng-container matColumnDef="webLinksExpand">
            <td mat-cell
                *matCellDef="let element; let index = dataIndex"
                [attr.colspan]="displayedColumns.length">
                <div class="example-element-detail"
                     [@detailExpand]="index === expandedElement ? 'expanded' : 'collapsed'">
                    <div class="series-cycle-list-element"
                         *ngFor="let cycle of getCyclesFormArray(index).controls; let i = index">
                        <app-series-cycle-form [form]="cycle"></app-series-cycle-form>
                        <button mat-button type="button" color="warn" (click)="deleteCycle(index, i)">
                            <fa-icon [icon]="['fas', 'trash']"></fa-icon>
                        </button>
                    </div>
                    <app-create-series-cycles (create)="addSeriesCycle($event, index)"></app-create-series-cycles>
                </div>
            </td>
        </ng-container>

        <ng-container matColumnDef="oneShot">
            <th mat-header-cell *matHeaderCellDef
                scope="col"> {{'SERIES.EDITION.TABLE.HEADERS.ONE_SHOT' | translate}}</th>
            <td mat-cell *matCellDef="let element; let index = dataIndex" [formGroup]="uiDatas[index].form">
                <div class="justify-center-child-items">
                    <mat-slide-toggle
                            [disabled]="uiDatas[index].item.status.possessedCount > 1"
                            [checked]="uiDatas[index].item.oneShot"
                            (change)="switchToOneShot($event, index)"
                            fxFlexAlign="end">
                    </mat-slide-toggle>
                </div>
            </td>
        </ng-container>

        <ng-container matColumnDef="action">
            <th mat-header-cell *matHeaderCellDef scope="col"></th>
            <td mat-cell *matCellDef="let element; let index = dataIndex" [formGroup]="uiDatas[index].form">
                <div class="action-column-edition">
                    <div class="action-column-edition-buttons">
                        <button mat-button type="button" color="warn" [disabled]="!isRemovable(index)"
                                (click)="delete(index)">
                            <fa-icon [icon]="['fas', 'trash']"></fa-icon>
                        </button>
                    </div>
                    <app-progressbar [start]="uiDatas[index].start" (finish)="onFinish(index)"></app-progressbar>
                </div>

            </td>
        </ng-container>

        <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
        <tr mat-row
            [ngClass]="{'edition-line': true, 'saved': (uiDatas[index].isSaved | async)}"
            *matRowDef="let element; columns: displayedColumns; let index = dataIndex">
        </tr>
        <tr mat-row *matRowDef="let row; columns: ['webLinksExpand']" class="example-detail-row"></tr>
    </table>
    <mat-paginator [pageSizeOptions]="pageSizes"
                   [pageIndex]="currentPage$ | async"
                   [length]="totalCount$ | async"
                   [pageSize]="pageSize$ | async"
                   (page)="onNewPage($event)">
    </mat-paginator>
</div>
